# AREA A1: the import statements
# import statements needed by esoreflex
from ipaddress import ip_address
import reflex
import sys
from argparse import ArgumentParser
import json
import os
import importlib
import json
import copy
import re

# Import statements needed by the 
# algorithm to execute
from astropy.io import fits as fits
import numpy as np

# END OF AREA A1
# AREA A2: the algorithm(s).
# END OF AREA A2
# AREA A3: the interface.
# This is the main Python script. It contains 2 general parts and a
# customized part, that is responsible of calling the desired
# reduction function.
# ------------------------------------------------------------------------------------------
def do_stuff() :
    return
# ------------------------------------------------------------------------------------------
if __name__ == '__main__':

    # ***  PART P1: Input/output ports ***

    #Define inputs/outputs
    parser = reflex.ReflexIOParser()
    #parser.add_option("--in_sofs", dest="ins_sofs")
    parser.add_option("--in_sop", dest="in_sop")
    parser.add_option("--in_set_init_sop", dest="in_set_init_sop")

    parser.add_output("--out_set_init_sop", dest="out_set_init_sop")

    inputs = parser.get_inputs()
    outputs = parser.get_outputs()

    #Define the list of outputs

    #Get the name of the output directory
    pattern = '^--products-dir='
    for arg in sys.argv:
        m=re.match(pattern, arg)
        if m is not None :
            output_dir = re.sub(pattern, '', arg)

    # ***  END OF PART P1 ***

    # ***  PART P2: customized part***
    set_init_sop=[]

    sop_keynames=[rp.name for rp in inputs.in_sop]
    o_attrs={}
    for p in inputs.in_set_init_sop :
        o_attrs[p.name]=p.value
    for _d in [o_attrs,] :
        for k in _d.keys() :
            if _d[k] is not None :
                if k in sop_keynames :
                    if inputs.in_sop[sop_keynames.index(k)].valtype == 'bool' :
                        if isinstance(_d[k],str) :
                            _d[k]=_d[k].lower() == 'true'
                    if _d[k] != inputs.in_sop[sop_keynames.index(k)].value :
                        set_init_sop+=[inputs.in_sop[sop_keynames.index(k)],]
                        set_init_sop[-1].value=_d[k]
    # *** END OF PART P2***

    # *** PART P3: broadcast products ***
  
    # After the script is completed, the list of products is
    # broadcasted to the output sof.
    outputs.out_sof = set_init_sop

    # Broadcast outputs on the extra output port.
    # broadcast outputs:
    parser.write_outputs()
    sys.exit()
    # ***  END OF PART P3 ***
    # ***  END OF AREA A3***    
